<?php
return array(
    'shop_abtest' => array(
        'id' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255),
        'create_datetime' => array('datetime', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_abtest_variants' => array(
        'id' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'abtest_id' => array('int', 11, 'unsigned' => 1, 'null' => 0),
        'code' => array('varchar', 16, 'null' => 0),
        'name' => array('varchar', 255),
        ':keys' => array(
            'PRIMARY' => 'id',
            'antest_code' => array('abtest_id', 'code', 'unique' => 1),
        ),
    ),
    'shop_affiliate_transaction' => array(
        'id' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'contact_id' => array('int', 11, 'unsigned' => 1, 'null' => 0),
        'create_datetime' => array('datetime', 'null' => 0),
        'order_id' => array('int', 11, 'unsigned' => 1),
        'amount' => array('decimal', "15,4", 'null' => 0),
        'balance' => array('decimal', "15,4", 'null' => 0),
        'comment' => array('text'),
        'type' => array('varchar', 32),
        ':keys' => array(
            'PRIMARY' => 'id',
            'contact_id' => 'contact_id',
        ),
    ),
    'shop_api_courier' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0),
        'enabled' => array('int', 1, 'null' => 0, 'default' => '1'),
        'contact_id' => array('int', 11),
        'create_datetime' => array('datetime', 'null' => 0),
        'orders_processed' => array('int', 11, 'null' => 0, 'default' => '0'),
        'note' => array('text'),
        'api_token' => array('varchar', 32),
        'api_pin' => array('varchar', 32),
        'api_pin_expire' => array('datetime'),
        'api_last_use' => array('datetime'),
        'all_storefronts' => array('int', 1, 'null' => 0, 'default' => '1'),
        'rights_order_edit' => array('int', 11, 'null' => 0, 'default' => '0'),
        'rights_customer_edit' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_api_courier_storefronts' => array(
        'courier_id' => array('int', 11, 'null' => 0),
        'storefront' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'courier' => 'courier_id',
        ),
    ),
    'shop_cart_items' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'code' => array('varchar', 32),
        'contact_id' => array('int', 11),
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11, 'null' => 0),
        'create_datetime' => array('datetime', 'null' => 0),
        'quantity' => array('decimal', "15,3", 'null' => 0, 'default' => '1.000'),
        'type' => array('enum', "'product','service'", 'null' => 0, 'default' => 'product'),
        'service_id' => array('int', 11),
        'service_variant_id' => array('int', 11),
        'parent_id' => array('int', 11),
        ':keys' => array(
            'PRIMARY' => 'id',
            'code' => 'code',
        ),
    ),
    'shop_category' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'left_key' => array('int', 11),
        'right_key' => array('int', 11),
        'depth' => array('int', 11, 'null' => 0, 'default' => '0'),
        'parent_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 255),
        'meta_title' => array('varchar', 255),
        'meta_keywords' => array('text'),
        'meta_description' => array('text'),
        'type' => array('int', 1, 'null' => 0, 'default' => '0'),
        'url' => array('varchar', 255),
        'full_url' => array('varchar', 255),
        'count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'description' => array('mediumtext'),
        'conditions' => array('text'),
        'create_datetime' => array('datetime', 'null' => 0),
        'edit_datetime' => array('datetime'),
        'filter' => array('text'),
        'sort_products' => array('varchar', 32),
        'include_sub_categories' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'url' => array('parent_id', 'url', 'unique' => 1),
            'full_url' => array('full_url', 'unique' => 1),
            'ns_keys' => array('left_key', 'right_key'),
        ),
    ),
    'shop_category_og' => array(
        'category_id' => array('int', 11, 'null' => 0),
        'property' => array('varchar', 255, 'null' => 0),
        'content' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('category_id', 'property'),
        ),
    ),
    'shop_category_params' => array(
        'category_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('category_id', 'name'),
        ),
    ),
    'shop_category_products' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'category_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('category_id', 'product_id'),
        ),
    ),
    'shop_category_routes' => array(
        'category_id' => array('int', 11, 'null' => 0),
        'route' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('category_id', 'route'),
        ),
    ),
    'shop_checkout_flow' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'code' => array('varchar', 32),
        'contact_id' => array('int', 11),
        'date' => array('date'),
        'year' => array('smallint', 6),
        'quarter' => array('smallint', 6),
        'month' => array('smallint', 6),
        'step' => array('tinyint', 2, 'null' => 0, 'default' => '0'),
        'description' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_contact_category_discount' => array(
        'category_id' => array('int', 10, 'unsigned' => 1, 'null' => 0),
        'discount' => array('decimal', "15,4", 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'category_id',
        ),
    ),
    'shop_coupon' => array(
        'id' => array('int', 10, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'code' => array('varchar', 32, 'null' => 0),
        'type' => array('varchar', 3, 'null' => 0),
        'limit' => array('int', 11),
        'used' => array('int', 11, 'null' => 0, 'default' => '0'),
        'value' => array('decimal', "15,4"),
        'url' => array('text'),
        'comment' => array('text'),
        'expire_datetime' => array('datetime'),
        'create_datetime' => array('datetime', 'null' => 0),
        'create_contact_id' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'default' => '0'),
        'products_hash' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'code' => array('code', 'unique' => 1),
        ),
    ),
    'shop_currency' => array(
        'code' => array('char', 3, 'null' => 0),
        'rate' => array('decimal', "18,10", 'null' => 0, 'default' => '1.0000000000'),
        'rounding' => array('decimal', "8,2", 'null' => 1, 'default' => null),
        'round_up_only' => array('int', 11, 'null' => 0, 'default' => '1'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'code',
        ),
    ),
    'shop_customer' => array(
        'contact_id' => array('int', 11, 'unsigned' => 1, 'null' => 0),
        'total_spent' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'affiliate_bonus' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'number_of_orders' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'default' => '0'),
        'last_order_id' => array('int', 11, 'unsigned' => 1),
        'source' => array('varchar', 255),
        ':keys' => array(
            'PRIMARY' => 'contact_id',
        ),
    ),
    'shop_customers_filter' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'hash' => array('text'),
        'create_datetime' => array('datetime', 'null' => 0),
        'contact_id' => array('int', 11, 'null' => 0),
        'mass_edit' => array('int', 11, 'null' => 1),
        'icon' => array('varchar', 255, 'null' => 1),
        ':keys' => array(
            'PRIMARY' => 'id',
            'contact_id' => 'contact_id',
        ),
    ),
    'shop_discount_by_sum' => array(
        'type' => array('varchar', 32, 'null' => 0),
        'sum' => array('decimal', "15,4", 'null' => 0),
        'discount' => array('decimal', "15,4", 'null' => 0),
        ':keys' => array(
        ),
    ),
    'shop_expense' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'type' => array('varchar', 16, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'storefront' => array('varchar', 255),
        'start' => array('date', 'null' => 0),
        'end' => array('date', 'null' => 0),
        'amount' => array('decimal', "15,4", 'null' => 0),
        'color' => array('varchar', 7),
        'note' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'start_end' => array('start', 'end'),
        ),
    ),
    'shop_feature' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'parent_id' => array('int', 11),
        'code' => array('varchar', 64, 'null' => 0),
        'status' => array('enum', "'public','hidden','private'", 'null' => 0, 'default' => 'public'),
        'name' => array('varchar', 255),
        'type' => array('varchar', 255),
        'selectable' => array('int', 11, 'null' => 0),
        'multiple' => array('int', 11, 'null' => 0),
        'count' => array('int', 10, 'unsigned' => 1, 'null' => 0, 'default' => '0'),
        'available_for_sku' => array('int', 11),
        'default_unit' => array('varchar', 255),
        'builtin' => array('int', 11, 'default' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'code' => array('code', 'unique' => 1),
        ),
    ),
    'shop_feature_values_color' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'code' => array('mediumint', 8, 'unsigned' => 1),
        'value' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'values' => array('feature_id', 'value', 'unique' => 1),
        ),
    ),
    'shop_feature_values_dimension' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'value' => array('double', 'null' => 0),
        'unit' => array('varchar', 255, 'null' => 0),
        'type' => array('varchar', 16, 'null' => 0),
        'value_base_unit' => array('double', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'feature_id' => array('feature_id', 'value', 'unit', 'type', 'unique' => 1),
        ),
    ),
    'shop_feature_values_double' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'value' => array('double', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'values' => array('feature_id', 'value', 'unique' => 1),
        ),
    ),
    'shop_feature_values_range' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'begin' => array('double'),
        'end' => array('double'),
        'unit' => array('varchar', 255, 'null' => 0),
        'type' => array('varchar', 16, 'null' => 0),
        'begin_base_unit' => array('double'),
        'end_base_unit' => array('double'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'feature_id' => array('feature_id', 'begin', 'end', 'unit', 'type', 'unique' => 1),
        ),
    ),
    'shop_feature_values_text' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_feature_values_varchar' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'value' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'values' => array('feature_id', 'value', 'unique' => 1),
        ),
    ),
    'shop_followup' => array(
        'id' => array('int', 10, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0),
        'delay' => array('int', 10, 'unsigned' => 1, 'null' => 0),
        'first_order_only' => array('tinyint', 3, 'unsigned' => 1, 'null' => 0, 'default' => '1'),
        'same_state_id' => array('tinyint', 4, 'default' => '0'),
        'subject' => array('text', 'null' => 0),
        'body' => array('text', 'null' => 0),
        'last_cron_time' => array('datetime', 'null' => 0),
        'from' => array('varchar', 32),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'transport' => array('enum', "'email','sms'", 'null' => 0, 'default' => 'email'),
        'state_id' => array('varchar', 32, 'default' => 'paid'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_followup_sources' => array(
        'followup_id' => array('int', 11, 'null' => 0),
        'source' => array('varchar', 510),
        ':keys' => array(
            'followup_id' => 'followup_id',
            'source' => array(array('source', '190')),
        ),
    ),
    'shop_importexport' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'plugin' => array('varchar', 64, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 255),
        'description' => array('text'),
        'config' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'id' => array('plugin', 'id', 'sort', 'unique' => 1),
        ),
    ),
    'shop_notification' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 128, 'null' => 0),
        'event' => array('varchar', 64, 'null' => 0),
        'transport' => array('enum', "'email','sms','http'", 'null' => 0, 'default' => 'email'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'event' => 'event',
        ),
    ),
    'shop_notification_params' => array(
        'notification_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 64, 'null' => 0),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('notification_id', 'name'),
        ),
    ),
    'shop_notification_sources' => array(
        'notification_id' => array('int', 11, 'null' => 0),
        'source' => array('varchar', 510),
        ':keys' => array(
            'notification_id' => 'notification_id',
            'source' => array(array('source', '190')),
        ),
    ),
    'shop_order' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'contact_id' => array('int', 11),
        'create_datetime' => array('datetime', 'null' => 0),
        'update_datetime' => array('datetime'),
        'state_id' => array('varchar', 32, 'null' => 0, 'default' => 'new'),
        'total' => array('decimal', "15,4", 'null' => 0),
        'currency' => array('char', 3, 'null' => 0),
        'rate' => array('decimal', "15,8", 'null' => 0, 'default' => '1.00000000'),
        'tax' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'shipping' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'discount' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'assigned_contact_id' => array('int', 11),
        'paid_year' => array('smallint', 6),
        'paid_quarter' => array('smallint', 6),
        'paid_month' => array('smallint', 6),
        'paid_date' => array('date', 'null' => 1, 'default' => null),
        'auth_date' => array('date', 'null' => 1, 'default' => null),
        'is_first' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'unsettled' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'comment' => array('text'),
        'shipping_datetime' => array('datetime'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'state_id' => 'state_id',
            'contact_id' => 'contact_id',
            'shipping_datetime' => 'shipping_datetime',
        ),
    ),
    'shop_order_item_codes' => array(
        'order_id' => array('int', 11, 'null' => 0),
        'order_item_id' => array('int', 11, 'null' => 0),
        'code_id' => array('int', 11),
        'code' => array('varchar', 64, 'null' => 0),
        'value' => array('text', 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'order_id' => 'order_id',
            'order_item_id' => 'order_item_id',
        ),
    ),
    'shop_order_items' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'order_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11, 'null' => 0),
        'sku_code' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'type' => array('enum', "'product','service'", 'null' => 0),
        'service_id' => array('int', 11),
        'service_variant_id' => array('int', 11),
        'price' => array('decimal', "15,4", 'null' => 0),
        'quantity' => array('decimal', "15,3", 'null' => 0),
        'quantity_denominator' => array('int', 10, 'unsigned' => 1, 'null' => 0, 'default' => '1'),
        'parent_id' => array('int', 11),
        'stock_id' => array('int', 11),
        'virtualstock_id' => array('int', 11),
        'stock_unit_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'purchase_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'total_discount' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'tax_percent' => array('decimal', "7,4"),
        'tax_included' => array('int', 1, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'order_type' => array('order_id', 'type'),
            'product_order' => array('product_id', 'order_id'),
        ),
    ),
    'shop_order_log' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'order_id' => array('int', 11, 'null' => 0),
        'contact_id' => array('int', 11),
        'action_id' => array('varchar', 32, 'null' => 0),
        'datetime' => array('datetime', 'null' => 0),
        'before_state_id' => array('varchar', 32, 'null' => 0),
        'after_state_id' => array('varchar', 32, 'null' => 0),
        'text' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'order_id' => 'order_id',
            'datetime' => 'datetime',
        ),
    ),
    'shop_order_log_params' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'order_id' => array('int', 11, 'null' => 0),
        'log_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'name' => array('order_id', 'log_id', 'name', 'unique' => 1),
        ),
    ),
    'shop_order_params' => array(
        'order_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 64, 'null' => 0),
        'value' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('order_id', 'name'),
            'name' => 'name',
        ),
    ),
    'shop_page' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'parent_id' => array('int', 11),
        'domain' => array('varchar', 255),
        'route' => array('varchar', 255),
        'name' => array('varchar', 255, 'null' => 0),
        'title' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'url' => array('varchar', 255),
        'full_url' => array('varchar', 255),
        'content' => array('mediumtext', 'null' => 0),
        'create_datetime' => array('datetime', 'null' => 0),
        'update_datetime' => array('datetime', 'null' => 0),
        'create_contact_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_page_params' => array(
        'page_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('page_id', 'name'),
        ),
    ),
    'shop_plugin' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'type' => array('varchar', 255, 'null' => 0),
        'plugin' => array('varchar', 255, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'description' => array('text', 'null' => 0),
        'logo' => array('text', 'null' => 0),
        'status' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0),
        'options' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'type' => 'type',
        ),
    ),
    'shop_plugin_settings' => array(
        'id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 64, 'null' => 0),
        'value' => array('mediumtext', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('id', 'name'),
        ),
    ),
    'shop_product' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255),
        'summary' => array('text'),
        'meta_title' => array('varchar', 255),
        'meta_keywords' => array('text'),
        'meta_description' => array('text'),
        'description' => array('mediumtext'),
        'contact_id' => array('int', 11),
        'create_datetime' => array('datetime', 'null' => 0),
        'edit_datetime' => array('datetime'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'type_id' => array('int', 11),
        'image_id' => array('int', 11),
        'image_filename' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'video_url' => array('varchar', 255),
        'sku_id' => array('int', 11),
        'ext' => array('varchar', 10),
        'url' => array('varchar', 255),
        'rating' => array('decimal', "3,2", 'null' => 0, 'default' => '0.00'),
        'price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'compare_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'currency' => array('char', 3),
        'min_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'max_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'tax_id' => array('int', 11),
        'count' => array('decimal', "15,3"),
        'count_denominator' => array('int', 10, 'unsigned' => 1, 'null' => 0, 'default' => '1'),
        'order_multiplicity_factor' => array('decimal', "9,3", 'null' => 0, 'default' => '1.000'),
        'stock_unit_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'base_unit_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'stock_base_ratio' => array('decimal', "16,8", 'unsigned' => 1, 'null' => 0, 'default' => '1.00000000'),
        'order_count_min' => array('decimal', "15,3", 'unsigned' => 1, 'null' => 0, 'default' => '1.000'),
        'order_count_step' => array('decimal', "15,3", 'unsigned' => 1, 'null' => 0, 'default' => '1.000'),
        'base_price' => array('decimal', "15,4", 'unsigned' => 1, 'null' => 0, 'default' => '0.0000'),
        'min_base_price' => array('decimal', "15,4", 'unsigned' => 1, 'null' => 0, 'default' => '0.0000'),
        'max_base_price' => array('decimal', "15,4", 'unsigned' => 1, 'null' => 0, 'default' => '0.0000'),
        'cross_selling' => array('tinyint', 1),
        'upselling' => array('tinyint', 1),
        'rating_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'total_sales' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'category_id' => array('int', 11),
        'badge' => array('text'),
        'sku_type' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'base_price_selectable' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'compare_price_selectable' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'purchase_price_selectable' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'sku_count' => array('int', 11, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'url' => 'url',
            'total_sales' => 'total_sales',
        ),
    ),
    'shop_product_code' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'code' => array('varchar', 64, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'icon' => array('varchar', 255),
        'logo' => array('varchar', 255),
        'protected' => array('tinyint', 1, 'default' => 0),
        'plugin_id' => array('varchar', 255),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_product_features' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11),
        'feature_id' => array('int', 11, 'null' => 0),
        'feature_value_id' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'feature' => array('product_id', 'sku_id', 'feature_id', 'feature_value_id', 'unique' => 1),
            'product_feature' => array('product_id', 'feature_id', 'feature_value_id'),
        ),
    ),
    'shop_product_features_selectable' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'feature_id' => array('int', 11, 'null' => 0),
        'value_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'feature_id', 'value_id'),
        ),
    ),
    'shop_product_images' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11, 'null' => 0),
        'upload_datetime' => array('datetime', 'null' => 0),
        'edit_datetime' => array('datetime'),
        'description' => array('varchar', 255),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'width' => array('int', 5, 'null' => 0, 'default' => '0'),
        'height' => array('int', 5, 'null' => 0, 'default' => '0'),
        'size' => array('int', 11),
        'filename' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'original_filename' => array('varchar', 255),
        'ext' => array('varchar', 10),
        'badge_type' => array('int', 4),
        'badge_code' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'product_id' => 'product_id',
        ),
    ),
    'shop_product_og' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'property' => array('varchar', 255, 'null' => 0),
        'content' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'property'),
        ),
    ),
    'shop_product_pages' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11),
        'name' => array('varchar', 255, 'null' => 0),
        'title' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'url' => array('varchar', 255),
        'content' => array('mediumtext', 'null' => 0),
        'create_datetime' => array('datetime', 'null' => 0),
        'update_datetime' => array('datetime', 'null' => 0),
        'create_contact_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'keywords' => array('text'),
        'description' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'product_id' => array('product_id', 'url'),
        ),
    ),
    'shop_product_params' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'value' => array('text', 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'name'),
        ),
    ),
    'shop_product_related' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'type' => array('enum', "'cross_selling','upselling'", 'null' => 0),
        'related_product_id' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'type', 'related_product_id'),
        ),
    ),
    'shop_product_reviews' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'left_key' => array('int', 11),
        'right_key' => array('int', 11),
        'depth' => array('int', 11, 'null' => 0, 'default' => '0'),
        'parent_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'product_id' => array('int', 11, 'null' => 0),
        'review_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'datetime' => array('datetime', 'null' => 0),
        'status' => array('enum', "'approved','deleted','moderation'", 'null' => 0, 'default' => 'approved'),
        'title' => array('varchar', 64),
        'text' => array('text'),
        'rate' => array('decimal', "3,2"),
        'contact_id' => array('int', 11, 'unsigned' => 1, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 50),
        'email' => array('varchar', 50),
        'images_count' => array('int', 11, 'default' => '0'),
        'site' => array('varchar', 100),
        'auth_provider' => array('varchar', 100),
        'ip' => array('int', 11),
        ':keys' => array(
            'PRIMARY' => 'id',
            'contact_id' => 'contact_id',
            'status' => 'status',
            'parent_id' => 'parent_id',
            'product_id' => array('product_id', 'review_id'),
        ),
    ),
    'shop_product_reviews_images' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'review_id' => array('int', 11),
        'product_id' => array('int', 11),
        'upload_datetime' => array('datetime', 'null' => 0),
        'edit_datetime' => array('datetime'),
        'description' => array('varchar', 255),
        'sort' => array('int', 11, 'default' => '0'),
        'width' => array('int', 5, 'default' => '0'),
        'height' => array('int', 5, 'default' => '0'),
        'size' => array('int', 11),
        'filename' => array('varchar', 255),
        'original_filename' => array('varchar', 255),
        'ext' => array('varchar', 10),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_product_services' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11),
        'service_id' => array('int', 11, 'null' => 0),
        'service_variant_id' => array('int', 11, 'null' => 0),
        'price' => array('decimal', "15,4"),
        'primary_price' => array('decimal', "15,4"),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'product_id' => array('product_id', 'sku_id', 'service_id', 'service_variant_id', 'unique' => 1),
            'service_id' => array('service_id', 'service_variant_id'),
        ),
    ),
    'shop_product_skus' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11, 'null' => 0),
        'sku' => array('varchar', 255, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'image_id' => array('int', 11),
        'price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'primary_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'purchase_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'compare_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'count' => array('decimal', "15,3"),
        'available' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'stock_base_ratio' => array('decimal', "16,8", 'unsigned' => 1),
        'order_count_min' => array('decimal', "15,3", 'unsigned' => 1),
        'order_count_step' => array('decimal', "15,3", 'unsigned' => 1),
        'dimension_id' => array('int', 11),
        'file_name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'file_size' => array('int', 11, 'null' => 0, 'default' => '0'),
        'file_description' => array('text'),
        'virtual' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'product_id' => 'product_id',
        ),
    ),
    'shop_product_stocks' => array(
        'sku_id' => array('int', 11, 'null' => 0),
        'stock_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'product_id' => array('int', 11, 'null' => 0),
        'count' => array('decimal', "15,3", 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('sku_id', 'stock_id'),
            'product_id' => array('product_id', 'sku_id'),
        ),
    ),
    'shop_product_stocks_log' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11, 'null' => 0),
        'stock_id' => array('int', 11),
        'stock_name' => array('varchar', 255),
        'before_count' => array('decimal', "15,3"),
        'after_count' => array('decimal', "15,3"),
        'diff_count' => array('decimal', "15,3"),
        'type' => array('varchar', 32, 'null' => 0),
        'description' => array('text'),
        'datetime' => array('datetime', 'null' => 0),
        'order_id' => array('int', 11),
        'transfer_id' => array('int', 11),
        ':keys' => array(
            'PRIMARY' => 'id',
            'product_id' => array('product_id', 'sku_id'),
            'stock_id' => 'stock_id',
        ),
    ),
    'shop_product_tags' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'tag_id' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'tag_id'),
        ),
    ),
    'shop_promo' => array(
        'id'                  => array('int', 10, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'name'                => array('text'),
        'enabled'             => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'consider_end_orders' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'text_id'             => array('varchar', 64),
        'note'                => array('text'),
        'start_datetime'      => array('datetime'),
        'finish_datetime'     => array('datetime'),
        'author_contact_id'   => array('int', 11),
        'create_datetime'     => array('datetime'),
        'update_datetime'     => array('datetime'),
        ':keys'               => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_promo_orders' => array(
        'order_id' => array('int', 10, 'unsigned' => 1, 'null' => 0),
        'promo_id' => array('int', 11, 'unsigned' => 1, 'null' => 0),
        ':keys'    => array(
            'PRIMARY' => array('order_id', 'promo_id'),
        ),
    ),
    'shop_promo_routes' => array(
        'promo_id' => array('int', 10, 'unsigned' => 1, 'null' => 0),
        'storefront' => array('varchar', 255, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('storefront', 'promo_id'),
        ),
    ),
    'shop_promo_rules' => array(
        'id'          => array('int', 11, 'unsigned' => 1, 'null' => 0, 'autoincrement' => 1),
        'promo_id'    => array('int', 10, 'unsigned' => 1, 'null' => 0),
        'rule_type'   => array('varchar', 32, 'null' => 0),
        'rule_params' => array('longtext'),
        ':keys'       => array(
            'PRIMARY'   => 'id',
            'promo_id'  => 'promo_id',
            'rule_type' => 'rule_type',
        ),
    ),
    'shop_push_client' => array(
        'contact_id' => array('int', 11, 'null' => 0),
        'client_id' => array('varchar', 64, 'null' => 0),
        'shop_url' => array('varchar', 255, 'null' => 0),
        'type' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'api_token' => array('varchar', 32),
        'create_datetime' => array('datetime'),
        ':keys' => array(
            'client' => array('client_id', 'unique' => 1),
        ),
    ),
    'shop_sales' => array(
        'hash' => array('varchar', 32, 'null' => 0),
        'date' => array('date', 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'order_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'sales' => array('float', 'null' => 0, 'default' => '0'),
        'shipping' => array('float', 'null' => 0, 'default' => '0'),
        'tax' => array('float', 'null' => 0, 'default' => '0'),
        'purchase' => array('float', 'null' => 0, 'default' => '0'),
        'cost' => array('float', 'null' => 0, 'default' => '0'),
        'new_customer_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('hash', 'name', 'date'),
            'hash_date' => array('hash', 'date'),
            'date' => 'date',
        ),
    ),
    'shop_search_index' => array(
        'word_id' => array('int', 11, 'null' => 0),
        'product_id' => array('int', 11, 'null' => 0),
        'weight' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'word_id'),
            'word' => array('word_id', 'product_id', 'weight'),
        ),
    ),
    'shop_search_word' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'name' => array('name', 'unique' => 1),
        ),
    ),
    'shop_service' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255),
        'description' => array('text'),
        'price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'currency' => array('char', 3),
        'variant_id' => array('int', 11, 'null' => 0),
        'tax_id' => array('int', 11, 'default' => '0'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_service_variants' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'service_id' => array('int', 11, 'null' => 0),
        'name' => array('varchar', 255),
        'price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'primary_price' => array('decimal', "15,4", 'null' => 0, 'default' => '0.0000'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'service_id' => 'service_id',
        ),
    ),
    'shop_set' => array(
        'id' => array('varchar', 64, 'null' => 0),
        'name' => array('varchar', 255),
        'rule' => array('varchar', 32),
        'type' => array('int', 1, 'default' => '0'),
        'count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'create_datetime' => array('datetime', 'null' => 0),
        'edit_datetime' => array('datetime'),
        'json_params' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_set_products' => array(
        'set_id' => array('varchar', 64, 'null' => 0),
        'product_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('set_id', 'product_id'),
        ),
    ),
    'shop_stock' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'low_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'critical_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 255),
        'public' => array('int', 1, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_stock_rules' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'stock_id' => array('int', 11),
        'virtualstock_id' => array('int', 11),
        'rule_type' => array('varchar', 255, 'null' => 0),
        'rule_data' => array('text'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_tag' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0),
        'count' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
            'name' => array('name', 'unique' => 1),
        ),
    ),
    'shop_tax' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'included' => array('int', 11, 'null' => 0, 'default' => '0'),
        'address_type' => array('varchar', 8, 'null' => 0, 'default' => 'shipping'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_tax_regions' => array(
        'tax_id' => array('int', 11, 'null' => 0),
        'country_iso3' => array('varchar', 3, 'null' => 0),
        'region_code' => array('varchar', 8),
        'tax_value' => array('decimal', "7,4", 'null' => 0, 'default' => '0.0000'),
        'tax_name' => array('varchar', 255),
        'params' => array('text'),
        ':keys' => array(
            'tax_country_region' => array('tax_id', 'country_iso3', 'region_code', 'unique' => 1),
        ),
    ),
    'shop_tax_zip_codes' => array(
        'tax_id' => array('int', 11, 'null' => 0),
        'zip_expr' => array('varchar', 16, 'null' => 0),
        'tax_value' => array('decimal', "7,4", 'null' => 0, 'default' => '0.0000'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('tax_id', 'zip_expr'),
        ),
    ),
    'shop_transfer' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'string_id' => array('varchar', 255),
        'create_datetime' => array('datetime'),
        'finalize_datetime' => array('datetime'),
        'status' => array('enum', "'sent','completed','cancelled'", 'null' => 0, 'default' => 'sent'),
        'stock_id_from' => array('int', 11, 'null' => 0),
        'stock_id_to' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => 'id',
            'string_id' => array('string_id', 'unique' => 1)
        )
    ),
    'shop_transfer_products' => array(
        'product_id' => array('int', 11, 'null' => 0),
        'sku_id' => array('int', 11, 'null' => 0),
        'transfer_id' => array('int', 11, 'null' => 0),
        'count' => array('decimal', "15,3", 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('product_id', 'sku_id', 'transfer_id')
        )
    ),
    'shop_type' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 255),
        'icon' => array('varchar', 255),
        'cross_selling' => array('varchar', 64, 'null' => 0, 'default' => 'alsobought'),
        'upselling' => array('tinyint', 1, 'null' => 0, 'default' => '0'),
        'count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'stock_unit_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'stock_unit_id' => array('int', 11, 'null' => 0, 'default' => '0'),
        'base_unit_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'base_unit_id' => array('int', 11, 'null' => 1),
        'stock_base_ratio_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'stock_base_ratio' => array('decimal', "16,8", 'unsigned' => 1, 'null' => 1),
        'count_denominator_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'count_denominator' => array('int', 11, 'unsigned' => 1, 'null' => 1),
        'order_multiplicity_factor_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'order_multiplicity_factor' => array('decimal', "9,3", 'null' => 1),
        'order_count_min_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'order_count_min' => array('decimal', "15,3", 'unsigned' => 1, 'null' => 1),
        'order_count_step_fixed' => array('int', 11, 'null' => 0, 'default' => '2'),
        'order_count_step' => array('decimal', "15,3", 'unsigned' => 1, 'null' => 1),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_type_codes' => array(
        'type_id' => array('int', 11, 'null' => 0),
        'code_id' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'type_code' => array('type_id', 'code_id', 'unique' => 1),
        ),
    ),
    'shop_type_features' => array(
        'type_id' => array('int', 11, 'null' => 0),
        'feature_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => array('type_id', 'feature_id'),
            'feature_id' => 'feature_id',
        ),
    ),
    'shop_type_services' => array(
        'type_id' => array('int', 11, 'null' => 0),
        'service_id' => array('int', 11, 'null' => 0),
        ':keys' => array(
            'PRIMARY' => array('type_id', 'service_id'),
            'service_id' => 'service_id',
        ),
    ),
    'shop_type_upselling' => array(
        'type_id' => array('int', 11, 'null' => 0),
        'feature' => array('varchar', 32, 'null' => 0),
        'feature_id' => array('int', 11),
        'cond' => array('varchar', 16, 'null' => 0),
        'value' => array('varchar', 255),
        ':keys' => array(
            'PRIMARY' => array('type_id', 'feature'),
        ),
    ),
    'shop_unit' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'short_name' => array('varchar', 255, 'null' => 0),
        'name' => array('varchar', 255, 'null' => 0),
        'name2' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'name5' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'okei_code' => array('varchar', 64, 'null' => 0),
        'storefront_name' => array('varchar', 255, 'null' => 0, 'default' => ''),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'status' => array('tinyint', 1, 'null' => 0, 'default' => '1'),
        'builtin' => array('tinyint', 1, 'null' => 1, 'default' => '0'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_virtualstock' => array(
        'id' => array('int', 11, 'null' => 0, 'autoincrement' => 1),
        'low_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'critical_count' => array('int', 11, 'null' => 0, 'default' => '0'),
        'sort' => array('int', 11, 'null' => 0, 'default' => '0'),
        'name' => array('varchar', 255),
        'public' => array('int', 1, 'null' => 0, 'default' => '1'),
        ':keys' => array(
            'PRIMARY' => 'id',
        ),
    ),
    'shop_virtualstock_stocks' => array(
        'virtualstock_id' => array('int', 11, 'null' => 0),
        'stock_id' => array('int', 11, 'null' => 0),
        'sort' => array('int', 11, 'null' => 0),
        ':keys' => array(
        ),
    ),
);
